/*   ¡Bienvenid@ a tu primer ejercicio en PIXO!      
     
     Este es el -Ejercicio 01- del -Curso Introductorio-.
     Hoy aprenderemos sobre el funcionamiento de Arduino IDE, 
     que partes tiene el codigo de Arduino y como cargar 
     nuestro primer programa a PIXO.
     
     ¡Comencemos!
*/

//LIBRERIAS
/*    Las Librerias son una colección de código que facilita la conexión a un
      sensor, pantalla, módulo, etc. Para usar la matriz led que tiene nuestro
      kit PIXO usamos las librerias de Adafruit.
      Para utilizar estas librerias, tenemos que instalarlas. 
      (Ver guia online o libro pag. 22)

      Una vez instaladas en nuestro Arduino IDE, podemos incluirlas 
      a nuestro programa con la sentencia #include

      A continuación se encuentran todas las librerias y definiciones para poder
      usar nuestra Matriz LED.
*/

//Librerias
#include <Adafruit_GFX.h>
#include <Adafruit_NeoMatrix.h>
#include <Adafruit_NeoPixel.h>
#ifndef PSTR                        //Hace feliz a Arduino :)
#define PSTR
#endif
#define PIN NUMERO                 //PIN para controlar la Matriz LED

//Definicion de la Matriz LED
Adafruit_NeoMatrix matrix = Adafruit_NeoMatrix(8, 8, PIN, NEO_MATRIX_BOTTOM + NEO_MATRIX_RIGHT + NEO_MATRIX_ROWS + NEO_MATRIX_PROGRESSIVE, NEO_GRB + NEO_KHZ800);


//SETUP
/*
     El setup es una funcion propia de Arduino que se utiliza
     para comenzar la configuracion del programa. Aqui se inician
     pines, variables y librerias. 
     
     Esta funcion se ejecuta una sola vez, es decir que solo va a
     funcionar una vez en todo el programa. Esta es la primera funcion
     que se hace cuando Arduino se enciende y/o cuando se apreta el boton 
     reset de la placa.

     En nuestro primer codigo utilizamos el setup para configurar 
     nuestra Matriz LED.
*/
void setup() {
  
  matrix.begin();                   //Inicia la Matriz LED
  matrix.setBrightness(40);         //Configuramos el brillo de nuestra Matriz. Podemos cambiar el brillo entre 0 y 255.
                            //Codigo de demostracion de la Matriz LED de PIXO
  
  //Si llegaste hasta aqui significa que termino el tutorial del Ejercicio 1, ahora envia el codigo a tu kit PIXO.
  //Nos vemos en el Ejercicio 2 para que tu aprendas a programar a PIXO!
}

//LOOP
/*    
 *    El loop es una funcion propia de Arduino, esta debe estar en todos
      los programas que escribamos. Aun no vamos a programar dentro de el.
*/
void loop() //Todavía no vamos a utilizar el void loop, pero igual lo tenemos que poner en el código para que funcione correctamente.
{
   demo();
}

//Funciones programadas para la demostracion de la Matriz LED PIXO.
//No es necesario que le presten atencion. Vamos a aprender como hacer todo esto en ejercicios posteriores.
void demo() {
  PIXO();
  RGB();
  rainbow();
  rainbowCenter();
  lines();
  rectangles();
  breakoutSim();
  snakeSim();
  circleEnd();
  delay(300);
  PIXO();
    matrix.clear();           
  matrix.show();            
  delay(200);               
}

int wheelPos = 0;

uint32_t Wheel(byte WheelPos)
{
  WheelPos = 255 - WheelPos;
  if (WheelPos < 85)
  {
    return matrix.Color(255 - WheelPos * 3, 0, WheelPos * 3);
  }
  else if (WheelPos < 170)
  {
    WheelPos -= 85;
    return matrix.Color(0, WheelPos * 3, 255 - WheelPos * 3);
  }
  else
  {
    WheelPos -= 170;
    return matrix.Color(WheelPos * 3, 255 - WheelPos * 3, 0);
  }
}

void PIXO() {
  matrix.setTextColor(matrix.Color(255, 0, 0)); //Selecciona el color. En este caso esta seleccionado el color rojo, entre los paréntesis se ubican los valores R,G,B (Red, Blue, Green) el máximo que se puede colocar de cada uno es 255, podemos jugar con esos valores para crear colores nuevos.
  matrix.setCursor(1, 1); //Se para en la posición del pixel 1
  matrix.print(F("P")); //Letra a representar
  matrix.show(); //Muestra los cambios
  delay(500);
  matrix.setCursor(1, 1); //Se para en la posición del pixel 1
  matrix.clear();
  matrix.print(F("I")); //Letra a representar
  matrix.show(); //Muestra los cambios
  delay(500);
  matrix.setCursor(1, 1); //Se para en la posición del pixel 1
  matrix.clear();
  matrix.print(F("X")); //Letra a representar
  matrix.show(); //Muestra los cambios
  delay(500);
  matrix.setCursor(1, 1); //Se para en la posición del pixel 1
  matrix.clear();
  matrix.print(F("O")); //Letra a representar
  matrix.show(); //Muestra los cambios
  delay(500);
  matrix.clear();
}
void RGB() {
  matrix.fillScreen(matrix.Color(255, 0, 0));
  matrix.show(); //Muestra los cambios
  delay(500);
  matrix.fillScreen(matrix.Color(0, 255, 0));
  matrix.show(); //Muestra los cambios
  delay(500);
  matrix.fillScreen(matrix.Color(0, 0, 255));
  matrix.show(); //Muestra los cambios
  delay(500);
  matrix.clear();
}
void rainbow() {
  for (long i = 0; i < 255; i += 1) {
    matrix.fillScreen(Wheel(i));
    matrix.show(); //Muestra los cambios
    delay(10);
  }
  matrix.clear();
}
void rainbowCenter() {
  for (long i = 0; i < 255; i += 1) {
    matrix.fillRect(0, 0, 8, 8, Wheel(i + 10));
    matrix.fillRect(1, 1, 6, 6, Wheel(i + 20));
    matrix.fillRect(2, 2, 4, 4, Wheel(i + 30));
    matrix.fillRect(3, 3, 2, 2, Wheel(i + 40));
    matrix.show(); //Muestra los cambios
    delay(10);
  }
  matrix.clear();
}
void lines() {
  for (int x = 0; x < 8; x ++) {
    for (int y = 0; y < 8; y++) {
      matrix.drawPixel(x, y, matrix.Color(255, 255, 255));
      matrix.show();
    }
    delay(10);
    matrix.clear();
  }
  for (int x = 7; x >= 0; x --) {
    for (int y = 7; y >= 0; y--) {
      matrix.drawPixel(x, y, matrix.Color(255, 255, 255));
      matrix.show();
    }
    delay(10);
    matrix.clear();
  }
  for (int y = 0; y < 8; y ++) {
    for (int x = 0; x < 8; x++) {
      matrix.drawPixel(x, y, matrix.Color(255, 255, 255));
      matrix.show();
    }
    delay(10);
    matrix.clear();
  }
  for (int y = 7; y >= 0; y --) {
    for (int x = 7; x >= 0; x--) {
      matrix.drawPixel(x, y, matrix.Color(255, 255, 255));
      matrix.show();
    }
    delay(10);
    matrix.clear();
  }
}
void rectangles() {
  for (int p = 3; p >= 0; p --) {
    matrix.drawRect(4 + p, 4 + p, 4 - p, 4 - p, matrix.Color(255, 255, 255));
    matrix.show();
    delay(100);
    matrix.clear();
  }
  for (int p = 3; p >= 0; p --) {
    matrix.drawRect(p, 4 + p, 4 - p, 4 - p, matrix.Color(255, 255, 255));
    matrix.show();
    delay(100);
    matrix.clear();
  }
  for (int p = 3; p >= 0; p --) {
    matrix.drawRect(p, p, 4 - p, 4 - p, matrix.Color(255, 255, 255));
    matrix.show();
    delay(100);
    matrix.clear();
  }
  for (int p = 3; p >= 0; p --) {
    matrix.drawRect(4 + p, p, 4 - p, 4 - p, matrix.Color(255, 255, 255));
    matrix.show();
    delay(100);
    matrix.clear();
  }
  for (int p = 8; p >= 0; p --) {
    matrix.drawRect(p, p, 8 - p, 8 - p, matrix.Color(255, 255, 255));
    matrix.show();
    delay(100);
    matrix.clear();
  }
  for (int p = 0; p < 8; p ++) {
    matrix.drawRect(p, p, 8 - p, 8 - p, matrix.Color(255, 255, 255));
    matrix.show();
    delay(100);
    matrix.clear();
  }
}
void breakoutSim() {
  /*Atari breakout*/

  for (int x = 1; x < 7; x++) {
    matrix.drawLine(0, x, 0, x + 2, matrix.Color(255, 255, 255));
    matrix.drawLine(7, x, 7, x + 2, matrix.Color(255, 255, 255));
    matrix.drawPixel(x, x + 1, matrix.Color(0, 255, 0));
    matrix.show();
    delay(100);
    matrix.clear();
  }
  for (int x = 6; x > 0; x--) {
    matrix.drawLine(0, x, 0, x + 2, matrix.Color(255, 255, 255));
    matrix.drawLine(7, 5, 7, 7, matrix.Color(255, 255, 255));
    matrix.drawPixel(x, x, matrix.Color(0, 255, 0));
    matrix.show();
    delay(100);
    matrix.clear();
  }
}
void snakeSim() {
  /*Snake*/
  byte bodyLenght = 5;
  byte bodySnake[10][10] = {{1, 1}, {0, 1}, {0, 2}, {0, 3}, {0, 4}};
  for (int e = 0; e < 4; e++) {
    matrix.drawPixel(5, 5, matrix.Color(255, 0, 0));
    for (int i = 0; i < bodyLenght; i++) {
      matrix.drawPixel(bodySnake[i][0], bodySnake[i][1],  (i == 0) ? matrix.Color(0, 255, 0) : matrix.Color(255, 255, 255));
    }

    matrix.show();
    delay(200);
    matrix.clear();

    for (int p = bodyLenght - 1; p > 0; p--) {
      byte posAuxX =  bodySnake[p - 1][0];
      byte posAuxY =  bodySnake[p - 1][1];
      bodySnake[p][0] = posAuxX;
      bodySnake[p][1] = posAuxY;
    }
    bodySnake[0][0] += 1;
  }
  for (int e = 0; e < 5; e++) {
    matrix.drawPixel(5, 5, matrix.Color(255, 0, 0));
    for (int i = 0; i < bodyLenght; i++) {
      matrix.drawPixel(bodySnake[i][0], bodySnake[i][1],  (i == 0) ? matrix.Color(0, 255, 0) : matrix.Color(255, 255, 255));
    }

    matrix.show();
    delay(200);
    matrix.clear();

    for (int p = bodyLenght - 1; p > 0; p--) {
      byte posAuxX =  bodySnake[p - 1][0];
      byte posAuxY =  bodySnake[p - 1][1];
      bodySnake[p][0] = posAuxX;
      bodySnake[p][1] = posAuxY;
    }
    bodySnake[0][1] += 1;
  }
}
void circleEnd() {
  for (int i = 1; i < 8; i++) {
    matrix.fillCircle(5, 5, i, matrix.Color(0, 255, 0));
    matrix.show();
    delay(100);
  }
  for (int i = 8; i > 0; i--) {
    matrix.clear();
    matrix.fillCircle(5, 5, i, matrix.Color(0, 255, 0));
    matrix.show();
    delay(100);
  }
  matrix.clear();
  matrix.show();
}
